searchNodes=[{"doc":"The Crontab.CronExpression module / struct.","ref":"Crontab.CronExpression.html","title":"Crontab.CronExpression","type":"module"},{"doc":"Defines the Cron interval. * * * * * * * | | | | | | | | | | | | | + -- :year Year ( range : 1900 - 3000 ) | | | | | + -- -- :weekday Day of the Week ( range : 1 - 7 , 1 standing for Monday ) | | | | + -- -- -- :month Month of the Year ( range : 1 - 12 ) | | | + -- -- -- -- :day Day of the Month ( range : 1 - 31 ) | | + -- -- -- -- -- :hour Hour ( range : 0 - 23 ) | + -- -- -- -- -- -- :minute Minute ( range : 0 - 59 ) + -- -- -- -- -- -- -- :second Second ( range : 0 - 59 ) The :extended attribute defines if the second is taken into account.","ref":"Crontab.CronExpression.html#__struct__/0","title":"Crontab.CronExpression.__struct__/0","type":"function"},{"doc":"Create a %Crontab.CronExpression{} via sigil. Examples iex&gt; ~e[*] % Crontab.CronExpression { extended : false , second : [ :* ] , minute : [ :* ] , hour : [ :* ] , day : [ :* ] , month : [ :* ] , weekday : [ :* ] , year : [ :* ] } iex&gt; ~e[*]e % Crontab.CronExpression { extended : true , second : [ :* ] , minute : [ :* ] , hour : [ :* ] , day : [ :* ] , month : [ :* ] , weekday : [ :* ] , year : [ :* ] } iex&gt; ~e[1 2 3 4 5 6 7]e % Crontab.CronExpression { extended : true , second : [ 1 ] , minute : [ 2 ] , hour : [ 3 ] , day : [ 4 ] , month : [ 5 ] , weekday : [ 6 ] , year : [ 7 ] }","ref":"Crontab.CronExpression.html#sigil_e/2","title":"Crontab.CronExpression.sigil_e/2","type":"function"},{"doc":"Convert Crontab.CronExpression struct to tuple List. Examples iex&gt; Crontab.CronExpression . to_condition_list % Crontab.CronExpression { ...&gt; minute : [ 1 ] , hour : [ 2 ] , day : [ 3 ] , month : [ 4 ] , weekday : [ 5 ] , year : [ 6 ] } [ { :minute , [ 1 ] } , { :hour , [ 2 ] } , { :day , [ 3 ] } , { :month , [ 4 ] } , { :weekday , [ 5 ] } , { :year , [ 6 ] } ] iex&gt; Crontab.CronExpression . to_condition_list % Crontab.CronExpression { ...&gt; extended : true , second : [ 0 ] , minute : [ 1 ] , hour : [ 2 ] , day : [ 3 ] , month : [ 4 ] , weekday : [ 5 ] , year : [ 6 ] } [ { :second , [ 0 ] } , { :minute , [ 1 ] } , { :hour , [ 2 ] } , { :day , [ 3 ] } , { :month , [ 4 ] } , { :weekday , [ 5 ] } , { :year , [ 6 ] } ]","ref":"Crontab.CronExpression.html#to_condition_list/1","title":"Crontab.CronExpression.to_condition_list/1","type":"function"},{"doc":"","ref":"Crontab.CronExpression.html#t:condition/0","title":"Crontab.CronExpression.condition/0","type":"type"},{"doc":"","ref":"Crontab.CronExpression.html#t:condition/2","title":"Crontab.CronExpression.condition/2","type":"type"},{"doc":"","ref":"Crontab.CronExpression.html#t:condition_list/0","title":"Crontab.CronExpression.condition_list/0","type":"type"},{"doc":"","ref":"Crontab.CronExpression.html#t:day/0","title":"Crontab.CronExpression.day/0","type":"type"},{"doc":"","ref":"Crontab.CronExpression.html#t:hour/0","title":"Crontab.CronExpression.hour/0","type":"type"},{"doc":"","ref":"Crontab.CronExpression.html#t:interval/0","title":"Crontab.CronExpression.interval/0","type":"type"},{"doc":"","ref":"Crontab.CronExpression.html#t:min_max/0","title":"Crontab.CronExpression.min_max/0","type":"type"},{"doc":"","ref":"Crontab.CronExpression.html#t:min_max/1","title":"Crontab.CronExpression.min_max/1","type":"type"},{"doc":"","ref":"Crontab.CronExpression.html#t:minute/0","title":"Crontab.CronExpression.minute/0","type":"type"},{"doc":"","ref":"Crontab.CronExpression.html#t:month/0","title":"Crontab.CronExpression.month/0","type":"type"},{"doc":"","ref":"Crontab.CronExpression.html#t:second/0","title":"Crontab.CronExpression.second/0","type":"type"},{"doc":"","ref":"Crontab.CronExpression.html#t:t/0","title":"Crontab.CronExpression.t/0","type":"type"},{"doc":"","ref":"Crontab.CronExpression.html#t:time_unit/0","title":"Crontab.CronExpression.time_unit/0","type":"type"},{"doc":"","ref":"Crontab.CronExpression.html#t:value/0","title":"Crontab.CronExpression.value/0","type":"type"},{"doc":"","ref":"Crontab.CronExpression.html#t:value/1","title":"Crontab.CronExpression.value/1","type":"type"},{"doc":"","ref":"Crontab.CronExpression.html#t:weekday/0","title":"Crontab.CronExpression.weekday/0","type":"type"},{"doc":"","ref":"Crontab.CronExpression.html#t:year/0","title":"Crontab.CronExpression.year/0","type":"type"},{"doc":"Generate from %CronExpression{} to * * * * * * .","ref":"Crontab.CronExpression.Composer.html","title":"Crontab.CronExpression.Composer","type":"module"},{"doc":"Generate from %Crontab.CronExpression{} to * * * * * * . Examples iex&gt; Crontab.CronExpression.Composer . compose % Crontab.CronExpression { } &quot;* * * * * *&quot; iex&gt; Crontab.CronExpression.Composer . compose % Crontab.CronExpression { minute : [ 9 , { :- , 4 , 6 } , { :/ , :* , 9 } ] } &quot;9,4-6,*/9 * * * * *&quot; iex&gt; Crontab.CronExpression.Composer . compose % Crontab.CronExpression { reboot : true } &quot;@reboot&quot;","ref":"Crontab.CronExpression.Composer.html#compose/1","title":"Crontab.CronExpression.Composer.compose/1","type":"function"},{"doc":"Provides a type for Ecto usage. The underlying data type should be a map. Migration Example create table ( :my_table ) do add :schedule , :map end Schema Example schema &quot;my_table&quot; do field :schedule , Crontab.CronExpression.Ecto.Type end","ref":"Crontab.CronExpression.Ecto.Type.html","title":"Crontab.CronExpression.Ecto.Type","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"Crontab.CronExpression.Ecto.Type.html#cast/1","title":"Crontab.CronExpression.Ecto.Type.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"Crontab.CronExpression.Ecto.Type.html#dump/1","title":"Crontab.CronExpression.Ecto.Type.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Crontab.CronExpression.Ecto.Type.html#embed_as/1","title":"Crontab.CronExpression.Ecto.Type.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Crontab.CronExpression.Ecto.Type.html#equal?/2","title":"Crontab.CronExpression.Ecto.Type.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"Crontab.CronExpression.Ecto.Type.html#load/1","title":"Crontab.CronExpression.Ecto.Type.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"Crontab.CronExpression.Ecto.Type.html#type/0","title":"Crontab.CronExpression.Ecto.Type.type/0","type":"function"},{"doc":"","ref":"Crontab.CronExpression.Ecto.Type.html#t:map_expression/0","title":"Crontab.CronExpression.Ecto.Type.map_expression/0","type":"type"},{"doc":"Parse string like * * * * * * to a %Crontab.CronExpression{} .","ref":"Crontab.CronExpression.Parser.html","title":"Crontab.CronExpression.Parser","type":"module"},{"doc":"Parse string like * * * * * * to a %CronExpression{} . Examples iex&gt; Crontab.CronExpression.Parser . parse &quot;* * * * *&quot; { :ok , % Crontab.CronExpression { day : [ :* ] , hour : [ :* ] , minute : [ :* ] , month : [ :* ] , weekday : [ :* ] , year : [ :* ] } } iex&gt; Crontab.CronExpression.Parser . parse &quot;* * * * *&quot; , true { :ok , % Crontab.CronExpression { extended : true , day : [ :* ] , hour : [ :* ] , minute : [ :* ] , month : [ :* ] , weekday : [ :* ] , year : [ :* ] , second : [ :* ] } } iex&gt; Crontab.CronExpression.Parser . parse &quot;fooo&quot; { :error , &quot;Can&#39;t parse fooo as minute.&quot; }","ref":"Crontab.CronExpression.Parser.html#parse/2","title":"Crontab.CronExpression.Parser.parse/2","type":"function"},{"doc":"Parse string like * * * * * * to a %CronExpression{} . Examples iex&gt; Crontab.CronExpression.Parser . parse! &quot;* * * * *&quot; % Crontab.CronExpression { day : [ :* ] , hour : [ :* ] , minute : [ :* ] , month : [ :* ] , weekday : [ :* ] , year : [ :* ] } iex&gt; Crontab.CronExpression.Parser . parse! &quot;* * * * *&quot; , true % Crontab.CronExpression { extended : true , day : [ :* ] , hour : [ :* ] , minute : [ :* ] , month : [ :* ] , weekday : [ :* ] , year : [ :* ] , second : [ :* ] } iex&gt; Crontab.CronExpression.Parser . parse! &quot;fooo&quot; ** (RuntimeError) Can&#39;t parse fooo as minute.","ref":"Crontab.CronExpression.Parser.html#parse!/2","title":"Crontab.CronExpression.Parser.parse!/2","type":"function"},{"doc":"","ref":"Crontab.CronExpression.Parser.html#t:result/0","title":"Crontab.CronExpression.Parser.result/0","type":"type"},{"doc":"This module is used to check a Crontab.CronExpression against a given date.","ref":"Crontab.DateChecker.html","title":"Crontab.DateChecker","type":"module"},{"doc":"Check a condition list against a given date. Examples iex&gt; Crontab.DateChecker . matches_date? % Crontab.CronExpression { minute : [ { :&quot;/&quot; , :* , 8 } ] } , ~N[2004-04-16 04:08:08] true iex&gt; Crontab.DateChecker . matches_date? % Crontab.CronExpression { minute : [ { :&quot;/&quot; , :* , 9 } ] } , ~N[2004-04-16 04:07:08] false iex&gt; Crontab.DateChecker . matches_date? % Crontab.CronExpression { reboot : true } , ~N[2004-04-16 04:07:08] ** (RuntimeError) Special identifier @reboot is not supported. iex&gt; Crontab.DateChecker . matches_date? [ { :hour , [ { :&quot;/&quot; , :* , 4 } , 7 ] } ] , ~N[2004-04-16 04:07:08] true","ref":"Crontab.DateChecker.html#matches_date?/2","title":"Crontab.DateChecker.matches_date?/2","type":"function"},{"doc":"Check a condition against a given date. Examples iex&gt; Crontab.DateChecker . matches_date? :hour , [ { :&quot;/&quot; , :* , 4 } , 7 ] , ~N[2004-04-16 04:07:08] true iex&gt; Crontab.DateChecker . matches_date? :hour , [ 8 ] , ~N[2004-04-16 04:07:08] false","ref":"Crontab.DateChecker.html#matches_date?/3","title":"Crontab.DateChecker.matches_date?/3","type":"function"},{"doc":"","ref":"Crontab.DateChecker.html#t:date/0","title":"Crontab.DateChecker.date/0","type":"type"},{"doc":"This module provides the functionality to retrieve the next run date or the previous run date from a %CronExpression{} .","ref":"Crontab.Scheduler.html","title":"Crontab.Scheduler","type":"module"},{"doc":"This function provides the functionality to retrieve the next run date from a %Crontab.CronExpression{} . Examples iex&gt; Crontab.Scheduler . get_next_run_date ( % Crontab.CronExpression { } , ~N[2002-01-13 23:00:07] ) { :ok , ~N[2002-01-13 23:01:00] } iex&gt; Crontab.Scheduler . get_next_run_date ( % Crontab.CronExpression { year : [ { :/ , :* , 9 } ] } , ~N[2002-01-13 23:00:07] ) { :ok , ~N[2007-01-01 00:00:00] } iex&gt; Crontab.Scheduler . get_next_run_date % Crontab.CronExpression { reboot : true } ** (RuntimeError) Special identifier @reboot is not supported.","ref":"Crontab.Scheduler.html#get_next_run_date/3","title":"Crontab.Scheduler.get_next_run_date/3","type":"function"},{"doc":"This function provides the functionality to retrieve the next run date from a %Crontab.CronExpression{} . Examples iex&gt; Crontab.Scheduler . get_next_run_date! ( % Crontab.CronExpression { } , ~N[2002-01-13 23:00:07] ) ~N[2002-01-13 23:01:00] iex&gt; Crontab.Scheduler . get_next_run_date! ( % Crontab.CronExpression { year : [ 1990 ] } , ~N[2002-01-13 23:00:07] ) ** (RuntimeError) No compliant date was found for your interval. iex&gt; Crontab.Scheduler . get_next_run_date! ( % Crontab.CronExpression { year : [ { :/ , :* , 9 } ] } , ~N[2002-01-13 23:00:07] ) ~N[2007-01-01 00:00:00] iex&gt; Crontab.Scheduler . get_next_run_date! % Crontab.CronExpression { reboot : true } ** (RuntimeError) Special identifier @reboot is not supported.","ref":"Crontab.Scheduler.html#get_next_run_date!/3","title":"Crontab.Scheduler.get_next_run_date!/3","type":"function"},{"doc":"Find the next execution dates relative to a given date from a %CronExpression{} . Examples iex&gt; Enum . take ( Crontab.Scheduler . get_next_run_dates ( ...&gt; % Crontab.CronExpression { extended : true } , ~N[2016-12-17 00:00:00] ) , 3 ) [ ~N[2016-12-17 00:00:00] , ~N[2016-12-17 00:00:01] , ~N[2016-12-17 00:00:02] ] iex&gt; Enum . take ( Crontab.Scheduler . get_next_run_dates ( % Crontab.CronExpression { } , ~N[2016-12-17 00:00:00] ) , 3 ) [ ~N[2016-12-17 00:00:00] , ~N[2016-12-17 00:01:00] , ~N[2016-12-17 00:02:00] ] iex&gt; Enum . take ( Crontab.Scheduler . get_next_run_dates ( % Crontab.CronExpression { ...&gt; year : [ 2017 ] , month : [ 1 ] , day : [ 1 ] , hour : [ 0 ] , minute : [ 1 ] } , ~N[2016-12-17 00:00:00] ) , 3 ) [ ~N[2017-01-01 00:01:00] ] iex&gt; Enum . take ( Crontab.Scheduler . get_next_run_dates ( % Crontab.CronExpression { reboot : true } ) , 3 ) ** (RuntimeError) Special identifier @reboot is not supported.","ref":"Crontab.Scheduler.html#get_next_run_dates/2","title":"Crontab.Scheduler.get_next_run_dates/2","type":"function"},{"doc":"This function provides the functionality to retrieve the previous run date from a %Crontab.CronExpression{} . Examples iex&gt; Crontab.Scheduler . get_previous_run_date % Crontab.CronExpression { } , ~N[2002-01-13 23:00:07] { :ok , ~N[2002-01-13 23:00:00] } iex&gt; Crontab.Scheduler . get_previous_run_date % Crontab.CronExpression { ...&gt; year : [ { :/ , :* , 9 } ] } , ~N[2002-01-13 23:00:07] { :ok , ~N[1998-12-31 23:59:00] } iex&gt; Crontab.Scheduler . get_previous_run_date % Crontab.CronExpression { reboot : true } ** (RuntimeError) Special identifier @reboot is not supported.","ref":"Crontab.Scheduler.html#get_previous_run_date/3","title":"Crontab.Scheduler.get_previous_run_date/3","type":"function"},{"doc":"This function provides the functionality to retrieve the previous run date from a %Crontab.CronExpression{} . Examples iex&gt; Crontab.Scheduler . get_previous_run_date! % Crontab.CronExpression { } , ~N[2002-01-13 23:00:07] ~N[2002-01-13 23:00:00] iex&gt; Crontab.Scheduler . get_previous_run_date! ( % Crontab.CronExpression { year : [ 2100 ] } , ~N[2002-01-13 23:00:07] ) ** (RuntimeError) No compliant date was found for your interval. iex&gt; Crontab.Scheduler . get_previous_run_date! % Crontab.CronExpression { ...&gt; year : [ { :/ , :* , 9 } ] } , ~N[2002-01-13 23:00:07] ~N[1998-12-31 23:59:00] iex&gt; Crontab.Scheduler . get_previous_run_date! % Crontab.CronExpression { reboot : true } ** (RuntimeError) Special identifier @reboot is not supported.","ref":"Crontab.Scheduler.html#get_previous_run_date!/3","title":"Crontab.Scheduler.get_previous_run_date!/3","type":"function"},{"doc":"Find the previous n execution dates relative to a given date from a %CronExpression{} . Examples iex&gt; Enum . take ( Crontab.Scheduler . get_previous_run_dates ( ...&gt; % Crontab.CronExpression { extended : true } , ~N[2016-12-17 00:00:00] ) , 3 ) [ ~N[2016-12-17 00:00:00] , ~N[2016-12-16 23:59:59] , ~N[2016-12-16 23:59:58] ] iex&gt; Enum . take ( Crontab.Scheduler . get_previous_run_dates ( % Crontab.CronExpression { } , ~N[2016-12-17 00:00:00] ) , 3 ) [ ~N[2016-12-17 00:00:00] , ~N[2016-12-16 23:59:00] , ~N[2016-12-16 23:58:00] ] iex&gt; Enum . take ( Crontab.Scheduler . get_previous_run_dates ( % Crontab.CronExpression { ...&gt; year : [ 2017 ] , month : [ 1 ] , day : [ 1 ] , hour : [ 0 ] , minute : [ 1 ] } , ~N[2016-12-17 00:00:00] ) , 3 ) [ ] iex&gt; Enum . take ( Crontab.Scheduler . get_previous_run_dates ( % Crontab.CronExpression { reboot : true } ) , 3 ) ** (RuntimeError) Special identifier @reboot is not supported.","ref":"Crontab.Scheduler.html#get_previous_run_dates/2","title":"Crontab.Scheduler.get_previous_run_dates/2","type":"function"},{"doc":"","ref":"Crontab.Scheduler.html#t:direction/0","title":"Crontab.Scheduler.direction/0","type":"type"},{"doc":"","ref":"Crontab.Scheduler.html#t:result/0","title":"Crontab.Scheduler.result/0","type":"type"},{"doc":"Elixir library for parsing, writing, and calculating Cron format strings.","ref":"readme.html","title":"Crontab","type":"extras"},{"doc":"Add :crontab to your list of dependencies in mix.exs : def deps do [ { :crontab , &quot;~&gt; 1.1&quot; } ] end For Elixir version before 1.4, ensure :crontab is started before your application: def application do [ applications : [ :crontab ] ] end","ref":"readme.html#installation","title":"Crontab - Installation","type":"extras"},{"doc":"Import Cron expression sigil Everywhere you want to use the Cron expression sigil ( e[cron expression] ). import Crontab.CronExpression Extended Cron expressions An extended Cron expression has more precision than a normal Cron expression. It also specifies the second. If you want to use extended Cron expressions with the sigil, just append an e . Checking if a Cron Expression Matches a date iex&gt; import Crontab.CronExpression iex&gt; Crontab.DateChecker . matches_date? ( ~e[*/2] , ~N[2017-01-01 01:01:00] ) false iex&gt; Crontab.DateChecker . matches_date? ( ~e[*] , ~N[2017-01-01 01:01:00] ) true Find Next / Previous Execution Date candidates All the date parameters default to now. For previous, just replace next in the code below. iex&gt; import Crontab.CronExpression iex&gt; Crontab.Scheduler . get_next_run_date ( ~e[*/2] , ~N[2017-01-01 01:01:00] ) { :ok , ~N[2017-01-01 01:02:00] } iex&gt; Crontab.Scheduler . get_next_run_date! ( ~e[*/2] , ~N[2017-01-01 01:01:00] ) ~N[2017-01-01 01:02:00] iex&gt; Crontab.Scheduler . get_next_run_dates ( 3 , ~e[*/2] , ~N[2017-01-01 01:01:00] ) { :ok , [ ~N[2017-01-01 01:02:00] , ~N[2017-01-01 01:04:00] , ~N[2017-01-01 01:06:00] ] } iex&gt; Crontab.Scheduler . get_next_run_dates! ( 3 , ~e[*/2] , ~N[2017-01-01 01:01:00] ) [ ~N[2017-01-01 01:02:00] , ~N[2017-01-01 01:04:00] , ~N[2017-01-01 01:06:00] ] Parse Cron Expressions If you statically define cron expressions, use the ~e[cron expression] sigil. For dynamic cron expressions, there is a Parser module. The parser module takes an optional extended flag. This is to mark if the expression contains seconds. This defaults to false . iex&gt; Crontab.CronExpression.Parser . parse &quot;* * * * *&quot; { :ok , % Crontab.CronExpression { day : [ :* ] , hour : [ :* ] , minute : [ :* ] , month : [ :* ] , weekday : [ :* ] , year : [ :* ] } } iex&gt; Crontab.CronExpression.Parser . parse! &quot;* * * * *&quot; % Crontab.CronExpression { day : [ :* ] , hour : [ :* ] , minute : [ :* ] , month : [ :* ] , weekday : [ :* ] , year : [ :* ] } Compose Cron expressions iex&gt; Crontab.CronExpression.Composer . compose % Crontab.CronExpression { } &quot;* * * * * *&quot; iex&gt; Crontab.CronExpression.Composer . compose % Crontab.CronExpression { minute : [ 9 , { :- , 4 , 6 } , { :/ , :* , 9 } ] } &quot;9,4-6,*/9 * * * * *&quot;","ref":"readme.html#usage","title":"Crontab - Usage","type":"extras"},{"doc":"Copyright (c) 2016, SK &amp; T AG, JOSHMARTIN GmbH, Jonatan Männchen This library is MIT licensed. See the LICENSE for details.","ref":"readme.html#copyright-and-license","title":"Crontab - Copyright and License","type":"extras"}]